<template>
  <div class="header">
    <div v-if="!showEdit" class="header__left current-city">
      {{ currentCity.name }}
    </div>
    <CitySelect
      v-if="showEdit"
      :options="cityOptions()"
      v-model="currentCityId"
      @hide="toggleEdit"
    />
    <div
      class="header__right degree-switcher"
      :class="{ 'degree-switcher--mob-hidden': showEdit }"
    >
      <div class="degree-switcher__text">º</div>
      <DegreeSwitcher v-model="currentDegree" :items="degreeItems" />
    </div>
    <div v-if="!showEdit" class="city-switcher">
      <div @click="toggleEdit" class="city-switcher__city-label">
        Сменить город
      </div>
      <div class="city-switcher__city-label">
        <ImageIcon class="city-switcher__arrow-icon" name="arrow" />
        Мое местоположение
      </div>
    </div>
  </div>
</template>

<script>
import ImageIcon from '@/components/ImageIcon'
import DegreeSwitcher from '@/components/TabsSwitcher'
import CitySelect from '@/components/CitySelect'
import store from '@/store/index.js'

export default {
  components: {
    ImageIcon,
    DegreeSwitcher,
    CitySelect
  },
  data: function() {
    return {
      currentDegree: { id: 'c', name: 'C' },
      degreeItems: [
        { id: 'c', name: 'C' },
        { id: 'f', name: 'F' }
      ],
      showEdit: false,
      cityOptions: function() {
        const options = {}
        const list = store.state.cityList

        for (let i = 0; i < list.length; i++) {
          options[list[i].id] = list[i].name
        }

        return options
      },
      currentCityId: store.state.currentCityId
    }
  },
  computed: {
    currentCity: function() {
      return store.getters.getCurrentCity
    }
  },
  watch: {
    currentCityId: function(newValue) {
      store.commit('setCityId', newValue)
    },
    currentDegree: function(newItem) {
      store.commit('setType', newItem.id)
    }
  },
  methods: {
    toggleEdit: function() {
      this.showEdit = !this.showEdit
    }
  }
}
</script>

<style lang="scss">
.header {
  height: 95px;
  display: flex;
  justify-content: space-between;
  align-items: flex-start;
  flex-wrap: wrap;
}

.degree-switcher {
  display: flex;
  align-items: center;

  &__text {
    font-size: 1.125rem;
    margin-right: 9px;
    opacity: 0.4;
  }

  &--mob-hidden {
    display: none;

    @include breakpoint(medium) {
      display: flex;
    }
  }
}

.current-city {
  font-size: 1.875rem;
  margin-bottom: 9px;
  line-height: 1.2;

  @include breakpoint(medium) {
    font-size: 3.125rem;
  }
}

.city-switcher {
  width: 100%;
  display: flex;
  justify-content: space-between;

  @include breakpoint(medium) {
    justify-content: flex-start;
  }

  &__city-label {
    @include font-label;

    cursor: pointer;
    display: flex;
    align-items: center;

    @include breakpoint(medium) {
      margin-right: 30px;
    }
  }

  &__arrow-icon {
    margin-right: 12px;
  }
}
</style>
